    SUBROUTINE reallocate_1d(growarray,newupperbound)
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!       This subroutine increases the size of a 1-dimensional array whose
!       upper bound has been exceeded.
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

      IMPLICIT NONE

      INTERFACE
        SUBROUTINE WriteError(errtype,problem,problemtype,solution,extraflag,extra1int,extra1ch)
          INTEGER, INTENT(in) :: errtype,extra1int
          CHARACTER(len=*), INTENT(in) :: extraflag,extra1ch,problemtype,problem,solution
        END SUBROUTINE WriteError
      END INTERFACE
        
      INTEGER,DIMENSION(:),ALLOCATABLE,INTENT(INOUT) :: growarray
      INTEGER,DIMENSION(:),ALLOCATABLE :: temparray
      INTEGER,INTENT(IN) :: newupperbound
      INTEGER :: oldupperbound,error
      CHARACTER(70)  :: problemtype
      CHARACTER(120)  :: errmessage,solution

      oldupperbound = SIZE(growarray)
      error = 0
      problemtype = 'Reallocate_1d'

      ALLOCATE(temparray(newupperbound),STAT=error)
      IF (error.ne.0) THEN
        errmessage = 'temporary array not reallocated successfully' 
        solution = 'reduce memory requirements. See "Practical Considerations" chapter of Scoops3D manual'
        Call WriteError(1,errmessage,problemtype,solution,'no ',0,' ')         
      END IF

      temparray(1:oldupperbound) = growarray

      CALL MOVE_ALLOC(temparray,growarray)

    END SUBROUTINE reallocate_1d
